module("luci.model.cbi.passwall.api.api",package.seeall)
fs=require"nixio.fs"
sys=require"luci.sys"
uci=require"luci.model.uci".cursor()
util=require"luci.util"
datatypes=require"luci.cbi.datatypes"
jsonc=require"luci.jsonc"
i18n=require"luci.i18n"
appname="passwall"
curl="/usr/bin/curl"
curl_args={"-skfL","--connect-timeout 3","--retry 3","-m 60"}
command_timeout=300
LEDE_BOARD=nil
DISTRIB_TARGET=nil
LOG_FILE="/tmp/log/"..appname..".log"
CACHE_PATH="/tmp/etc/"..appname.."_tmp"
function base64Decode(e)
local a=e
if not e then return''end
e=e:gsub("%z","")
e=e:gsub("%c","")
e=e:gsub("_","/")
e=e:gsub("-","+")
local t=#e%4
e=e..string.sub('====',t+1)
local e=nixio.bin.b64decode(e)
if e then
return e:gsub("%z","")
else
return a
end
end
function url(...)
local e=string.format("admin/services/%s",appname)
local t={...}
for a,t in pairs(t)do
if t~=""then
e=e.."/"..t
end
end
return require"luci.dispatcher".build_url(e)
end
function trim(e)
return(e:gsub("^%s*(.-)%s*$","%1"))
end
function is_exist(e,t)
for a,e in ipairs(e)do
if e==t then
return true
end
end
return false
end
function repeat_exist(t,a)
local e=0
for o,t in ipairs(t)do
if t:find("-")and t==a then
e=e+1
end
end
if e>1 then
return true
end
return false
end
function remove(...)
for t,e in ipairs({...})do
if e and#e>0 and e~="/"then
sys.call(string.format("rm -rf %s",e))
end
end
end
function is_install(e)
if e and#e>0 then
return sys.call(string.format('opkg list-installed | grep "%s" > /dev/null 2>&1',e))==0
end
return false
end
function get_args(t)
local a={}
for e,o in pairs(t)do
if e>0 then
local e=t[e+1]
if e then
if repeat_exist(t,e)==false then
a[o]=e
end
end
end
end
return a
end
function strToTable(e)
if e==nil or type(e)~="string"then
return{}
end
return loadstring("return "..e)()
end
function is_normal_node(e)
if e and e.type and e.protocol and(e.protocol=="_balancing"or e.protocol=="_shunt")then
return false
end
return true
end
function is_special_node(e)
return is_normal_node(e)==false
end
function is_ip(e)
if is_ipv6(e)then
e=get_ipv6_only(e)
end
return datatypes.ipaddr(e)
end
function is_ipv6(t)
local e=t
local t=t:match('%[(.*)%]')
if t then
e=t
end
if datatypes.ip6addr(e)then
return true
end
return false
end
function is_ipv6addrport(e)
if is_ipv6(e)then
local t,e=e:match('%[(.*)%]:([^:]+)$')
if e then
return datatypes.port(e)
end
end
return false
end
function get_ipv6_only(e)
local t=""
if is_ipv6(e)then
t=e
if e:match('%[(.*)%]')then
t=e:match('%[(.*)%]')
end
end
return t
end
function get_ipv6_full(t)
local e=""
if is_ipv6(t)then
e=t
if not t:match('%[(.*)%]')then
e="["..e.."]"
end
end
return e
end
function get_ip_type(e)
if is_ipv6(e)then
return"6"
elseif datatypes.ip4addr(e)then
return"4"
end
return""
end
function is_mac(e)
return datatypes.macaddr(e)
end
function ip_or_mac(e)
if e then
if get_ip_type(e)=="4"then
return"ip"
end
if is_mac(e)then
return"mac"
end
end
return""
end
function iprange(e)
if e then
local t,e=e:match("^([^/]+)-([^/]+)$")
if(t and datatypes.ip4addr(t))and(e and datatypes.ip4addr(e))then
return true
end
end
return false
end
function get_domain_from_url(t)
local e=string.match(t,"//([^/]+)")
if e then
return e
end
return t
end
function get_valid_nodes()
local i=uci_get_type("global_other","nodes_ping")or""
local o={}
uci:foreach(appname,"nodes",function(e)
e.id=e[".name"]
if e.type and e.remarks then
if e.protocol and(e.protocol=="_balancing"or e.protocol=="_shunt")then
e["remark"]="%s：[%s] "%{i18n.translatef(e.type..e.protocol),e.remarks}
e["node_type"]="special"
o[#o+1]=e
end
if e.port and e.address then
local t=e.address
if is_ip(t)or datatypes.hostname(t)then
local a=e.type
if(a=="V2ray"or a=="Xray")and e.protocol then
local e=e.protocol
if e=="vmess"then
e="VMess"
elseif e=="vless"then
e="VLESS"
else
e=e:gsub("^%l",string.upper)
end
a=a.." "..e
end
if is_ipv6(t)then t=get_ipv6_full(t)end
e["remark"]="%s：[%s]"%{a,e.remarks}
if i:find("info")then
e["remark"]="%s：[%s] %s:%s"%{a,e.remarks,t,e.port}
end
e.node_type="normal"
o[#o+1]=e
end
end
end
end)
return o
end
function get_full_node_remarks(e)
local t=""
if e then
if e.protocol and(e.protocol=="_balancing"or e.protocol=="_shunt")then
t="%s：[%s] "%{i18n.translatef(e.type..e.protocol),e.remarks}
else
local a=e.type
if(e.type=="V2ray"or e.type=="Xray")and e.protocol then
local e=e.protocol
if e=="vmess"then
e="VMess"
elseif e=="vless"then
e="VLESS"
else
e=e:gsub("^%l",string.upper)
end
a=a.." "..e
end
t="%s：[%s] %s:%s"%{a,e.remarks,e.address,e.port}
end
end
return t
end
function gen_uuid(t)
local e=sys.exec("echo -n $(cat /proc/sys/kernel/random/uuid)")
if t==nil then
e=string.gsub(e,"-","")
end
return e
end
function uci_get_type(e,a,t)
local e=uci:get_first(appname,e,a,t)or sys.exec("echo -n $(uci -q get "..appname..".@"..e.."[0]."..a..")")
if(e==nil or e=="")and(t and t~="")then
e=t
end
return e
end
function uci_get_type_id(t,a,e)
local t=uci:get(appname,t,a,e)or sys.exec("echo -n $(uci -q get "..appname.."."..t.."."..a..")")
if(t==nil or t=="")and(e and e~="")then
t=e
end
return t
end
function chmod_755(e)
if e and e~=""then
if not fs.access(e,"rwx","rx","rx")then
fs.chmod(e,755)
end
end
end
function get_customed_path(e)
return uci_get_type("global_app",e.."_file")
end
function is_finded(e)
return luci.sys.exec('type -t -p "/bin/%s" -p "%s" "%s"'%{e,get_customed_path(e),e})~=""and true or false
end
function clone(i)
local function o(e,a)
for e,t in pairs(e)do
if type(t)~="table"then
a[e]=t;
else
a[e]={};
o(t,a[e])
end
end
end
local e={}
o(i,e)
return e
end
function get_bin_version_cache(e,a)
sys.call("mkdir -p /tmp/etc/passwall_tmp")
if fs.access(e)then
chmod_755(e)
local t=sys.exec("echo -n $(md5sum "..e.." | awk '{print $1}')")
if fs.access("/tmp/etc/passwall_tmp/"..t)then
return sys.exec("echo -n $(cat /tmp/etc/passwall_tmp/%s)"%t)
else
local e=sys.exec(string.format("echo -n $(%s %s)",e,a))
if e and e~=""then
sys.call("echo '"..e.."' > ".."/tmp/etc/passwall_tmp/"..t)
return e
end
end
end
return""
end
function get_v2ray_path()
local e=uci_get_type("global_app","v2ray_file")
return e
end
function get_v2ray_version(e)
if e==nil then e=get_v2ray_path()end
local t="version | awk '{print $2}' | sed -n 1P"
return get_bin_version_cache(e,t)
end
function get_xray_path()
local e=uci_get_type("global_app","xray_file")
return e
end
function get_xray_version(e)
if e==nil then e=get_xray_path()end
local t="-version | awk '{print $2}' | sed -n 1P"
return get_bin_version_cache(e,t)
end
function get_trojan_go_path()
local e=uci_get_type("global_app","trojan_go_file")
return e
end
function get_trojan_go_version(e)
if e==nil then e=get_trojan_go_path()end
local t="-version | awk '{print $2}' | sed -n 1P"
return get_bin_version_cache(e,t)
end
function get_brook_path()
local e=uci_get_type("global_app","brook_file")
return e
end
function get_brook_version(e)
if e==nil then e=get_brook_path()end
local t="-v | awk '{print $3}'"
return get_bin_version_cache(e,t)
end
function get_hysteria_path()
local e=uci_get_type("global_app","hysteria_file")
return e
end
function get_hysteria_version(e)
if e==nil then e=get_hysteria_path()end
local t="-v | awk '{print $3}'"
return get_bin_version_cache(e,t)
end
function is_file(e)
if e and#e>1 then
if sys.exec('[ -f "%s" ] && echo -n 1'%e)=="1"then
return true
end
end
return nil
end
function is_dir(e)
if e and#e>1 then
if sys.exec('[ -d "%s" ] && echo -n 1'%e)=="1"then
return true
end
end
return nil
end
function get_final_dir(e)
if is_dir(e)then
return e
else
return get_final_dir(fs.dirname(e))
end
end
function get_free_space(e)
if e==nil then e="/"end
if sys.call("df -k "..e.." >/dev/null 2>&1")==0 then
return tonumber(sys.exec("echo -n $(df -k "..e.." | awk 'NR>1' | awk '{print $4}')"))
end
return 0
end
function get_file_space(e)
if e==nil then return 0 end
if fs.access(e)then
return tonumber(sys.exec("echo -n $(du -k "..e.." | awk '{print $1}')"))
end
return 0
end
function _unpack(t,e)
e=e or 1
if t[e]~=nil then return t[e],_unpack(t,e+1)end
end
function exec(h,r,i,a)
local o=require"os"
local e=require"nixio"
local s,n=e.pipe()
local t=e.fork()
if t>0 then
n:close()
if i or a then
local n=o.time()
while true do
if a and o.difftime(o.time(),n)>=a then
e.kill(t,e.const.SIGTERM)
return 1
end
if i then
local e=s:read(2048)
if e and#e>0 then
i(e)
end
end
local n,o,t=e.waitpid(t,"nohang")
if n and o=="exited"then return t end
if not i and a then e.nanosleep(1)end
end
else
local a,t,e=e.waitpid(t)
return a and t=="exited"and e
end
elseif t==0 then
e.dup(n,e.stdout)
s:close()
n:close()
e.exece(h,r,nil)
e.stdout:close()
o.exit(1)
end
end
function compare_versions(t,e,a)
local i=table
if not t then t=""end
if not a then a=""end
local n=util.split(t,"[%.%-]",nil,true)
local o=util.split(a,"[%.%-]",nil,true)
local t=i.getn(n)
local a=i.getn(o)
if(t<a)then t=a end
for a=1,t,1 do
local t=tonumber(n[a]or 0)or 0
local a=tonumber(o[a]or 0)or 0
if e=="~="and(t~=a)then return true end
if(e=="<"or e=="<=")and(t<a)then return true end
if(e==">"or e==">=")and(t>a)then return true end
if(t~=a)then return false end
end
return not(e=="<"or e==">")
end
function auto_get_arch()
local e=nixio.uname().machine or""
if fs.access("/usr/lib/os-release")then
LEDE_BOARD=sys.exec("echo -n $(grep 'LEDE_BOARD' /usr/lib/os-release | awk -F '[\\042\\047]' '{print $2}')")
end
if fs.access("/etc/openwrt_release")then
DISTRIB_TARGET=sys.exec("echo -n $(grep 'DISTRIB_TARGET' /etc/openwrt_release | awk -F '[\\042\\047]' '{print $2}')")
end
if e=="mips"then
if LEDE_BOARD and LEDE_BOARD~=""then
if string.match(LEDE_BOARD,"ramips")=="ramips"then
e="ramips"
else
e=sys.exec("echo '"..LEDE_BOARD.."' | grep -oE 'ramips|ar71xx'")
end
elseif DISTRIB_TARGET and DISTRIB_TARGET~=""then
if string.match(DISTRIB_TARGET,"ramips")=="ramips"then
e="ramips"
else
e=sys.exec("echo '"..DISTRIB_TARGET.."' | grep -oE 'ramips|ar71xx'")
end
end
end
return util.trim(e)
end
function get_file_info(e)
local t=""
local a=""
if e=="x86_64"then
t="amd64"
elseif e=="aarch64"then
t="arm64"
elseif e=="ramips"then
t="mipsle"
elseif e=="ar71xx"then
t="mips"
elseif e:match("^i[%d]86$")then
t="386"
elseif e:match("^armv[5-8]")then
t="arm"
a=e:match("[5-8]")
if LEDE_BOARD and string.match(LEDE_BOARD,"bcm53xx")=="bcm53xx"then
a="5"
elseif DISTRIB_TARGET and string.match(DISTRIB_TARGET,"bcm53xx")==
"bcm53xx"then
a="5"
end
a="5"
end
return t,a
end
function get_api_json(e)
local t=require"luci.jsonc"
local e=luci.sys.exec(curl.." ".._unpack(curl_args).." "..e)
if e==""then return{}end
return t.parse(e)or{}
end
function common_to_check(e,t,i)
local e=get_api_json(e)
if#e>0 then
e=e[1]
end
if e.tag_name==nil then
return{
code=1,
error=i18n.translate("Get remote version info failed.")
}
end
local o=e.tag_name
local a=compare_versions(t:match("[^v]+"),"<",o:match("[^v]+"))
if not a then
return{
code=0,
local_version=t,
remote_version=o
}
end
local a={}
for t,e in ipairs(e.assets)do
if e.name and e.name:match(i)then
a=e
break
end
end
if not a.browser_download_url then
return{
code=1,
local_version=t,
remote_version=o,
html_url=e.html_url,
data=a,
error=i18n.translate("New version found, but failed to get new version download url.")
}
end
return{
code=0,
has_update=true,
local_version=t,
remote_version=o,
html_url=e.html_url,
data=a
}
end