module("luci.model.cbi.passwall.api.trojan_go",package.seeall)
local e=require"luci.model.cbi.passwall.api.api"
local s=e.fs
local a=e.sys
local i=e.util
local t=e.i18n
local o="https://api.github.com/repos/p4gefau1t/trojan-go/releases?per_page=1"
local o="https://api.github.com/repos/p4gefau1t/trojan-go/releases/latest"
local n=o
local o=e.get_trojan_go_path()or""
function check_path()
if o==""then
return{
code=1,
error=t.translatef("You did not fill in the %s path. Please save and apply then update manually.","Trojan-GO")
}
end
return{
code=0
}
end
function to_check(a)
local o=check_path()
if o.code~=0 then
return o
end
if not a or a==""then a=e.auto_get_arch()end
local a,o=e.get_file_info(a)
if a==""then
return{
code=1,
error=t.translate("Can't determine ARCH, or ARCH not supported.")
}
end
if a=="mips"then a="mips%-hardfloat"end
if a=="mipsle"then a="mipsle%-hardfloat"end
if a=="arm64"then
a="armv8"
else
if o and o:match("^[5-8]$")then a=a.."v"..o end
end
return e.common_to_check(n,e.get_trojan_go_version(),"linux%-"..a.."%.zip")
end
function to_download(o,s)
local n=check_path()
if n.code~=0 then
return n
end
if not o or o==""then
return{code=1,error=t.translate("Download url is required.")}
end
a.call("/bin/rm -f /tmp/trojan-go_download.*")
local a=i.trim(i.exec("mktemp -u -t trojan-go_download.XXXXXX"))
if s then
local e=e.get_free_space("/tmp")
if tonumber(s)>tonumber(e)then
return{code=1,error=t.translatef("%s not enough space.","/tmp")}
end
end
n=e.exec(e.curl,{e._unpack(e.curl_args),"-o",a,o},nil,e.command_timeout)==0
if not n then
e.exec("/bin/rm",{"-f",a})
return{
code=1,
error=t.translatef("File download failed or timed out: %s",o)
}
end
return{code=0,file=a}
end
function to_extract(o,n)
local n=check_path()
if n.code~=0 then
return n
end
if not o or o==""or not s.access(o)then
return{code=1,error=t.translate("File path required.")}
end
if a.exec("echo -n $(opkg list-installed | grep -c unzip)")~="1"then
e.exec("/bin/rm",{"-f",o})
return{
code=1,
error=t.translate("Not installed unzip, Can't unzip!")
}
end
a.call("/bin/rm -rf /tmp/trojan-go_extract.*")
local n=e.get_file_space(o)
local a=e.get_free_space("/tmp")
if a<=0 or a<=n then
return{code=1,error=t.translatef("%s not enough space.","/tmp")}
end
local a=i.trim(i.exec("mktemp -d -t trojan-go_extract.XXXXXX"))
local t={}
e.exec("/usr/bin/unzip",{"-o",o,"-d",a},
function(e)t[#t+1]=e end)
local t=i.split(table.concat(t))
e.exec("/bin/rm",{"-f",o})
return{code=0,file=a}
end
function to_move(n)
local i=check_path()
if i.code~=0 then
return i
end
if not n or n==""then
a.call("/bin/rm -rf /tmp/trojan-go_extract.*")
return{code=1,error=t.translate("Client file is required.")}
end
local h=n.."/trojan-go"
local n=e.get_trojan_go_version(h)
if n==""then
a.call("/bin/rm -rf /tmp/trojan-go_extract.*")
return{
code=1,
error=t.translate("The client file is not suitable for current device.")
}
end
local r=a.call('pgrep -af "passwall/.*trojan-go" >/dev/null')
if r==0 then
a.call("/etc/init.d/passwall stop")
end
local d=0
if s.access(o)then
d=e.get_file_space(o)
end
local u=e.get_file_space(h)
local l=e.get_final_dir(o)
local n=e.get_free_space(l)
if n>0 then
n=n+d
if u>n then
a.call("/bin/rm -rf /tmp/trojan-go_extract.*")
return{code=1,error=t.translatef("%s not enough space.",l)}
end
end
i=e.exec("/bin/mv",{"-f",h,o},nil,e.command_timeout)==0
a.call("/bin/rm -rf /tmp/trojan-go_extract.*")
if r==0 then
a.call("/etc/init.d/passwall restart >/dev/null 2>&1 &")
end
if not i or not s.access(o)then
return{
code=1,
error=t.translatef("Can't move new file to path: %s",o)
}
end
return{code=0}
end
