module("luci.model.cbi.passwall.api.v2ray",package.seeall)
local e=require"luci.model.cbi.passwall.api.api"
local s=e.fs
local o=e.sys
local n=e.util
local t=e.i18n
local a="https://api.github.com/repos/v2fly/v2ray-core/releases?per_page=1"
local i="https://api.github.com/repos/v2fly/v2ray-core/releases/latest"
local h=a
local i=e.get_v2ray_path()or""
function check_path()
if i==""then
return{
code=1,
error=t.translatef("You did not fill in the %s path. Please save and apply then update manually.","V2ray")
}
end
return{
code=0
}
end
function to_check(a)
local o=check_path()
if o.code~=0 then
return o
end
if not a or a==""then a=e.auto_get_arch()end
local a,o=e.get_file_info(a)
if a==""then
return{
code=1,
error=t.translate("Can't determine ARCH, or ARCH not supported.")
}
end
if a=="amd64"then a="64"end
if a=="386"then a="32"end
if a=="mipsle"then a="mips32le"end
if a=="mips"then a="mips32"end
if a=="arm"then a="arm32"end
return e.common_to_check(h,e.get_v2ray_version(),"linux%-"..a..(o~=""and".+"..o or""))
end
function to_download(a,s)
local i=check_path()
if i.code~=0 then
return i
end
if not a or a==""then
return{code=1,error=t.translate("Download url is required.")}
end
o.call("/bin/rm -f /tmp/v2ray_download.*")
local o=n.trim(n.exec("mktemp -u -t v2ray_download.XXXXXX"))
if s then
local e=e.get_free_space("/tmp")
if tonumber(s)>tonumber(e)then
return{code=1,error=t.translatef("%s not enough space.","/tmp")}
end
end
i=e.exec(e.curl,{e._unpack(e.curl_args),"-o",o,a},nil,e.command_timeout)==0
if not i then
e.exec("/bin/rm",{"-f",o})
return{
code=1,
error=t.translatef("File download failed or timed out: %s",a)
}
end
return{code=0,file=o}
end
function to_extract(a,i)
local i=check_path()
if i.code~=0 then
return i
end
if not a or a==""or not s.access(a)then
return{code=1,error=t.translate("File path required.")}
end
if o.exec("echo -n $(opkg list-installed | grep -c unzip)")~="1"then
e.exec("/bin/rm",{"-f",a})
return{
code=1,
error=t.translate("Not installed unzip, Can't unzip!")
}
end
o.call("/bin/rm -rf /tmp/v2ray_extract.*")
local i=e.get_file_space(a)
local o=e.get_free_space("/tmp")
if o<=0 or o<=i then
return{code=1,error=t.translatef("%s not enough space.","/tmp")}
end
local o=n.trim(n.exec("mktemp -d -t v2ray_extract.XXXXXX"))
local t={}
e.exec("/usr/bin/unzip",{"-o",a,"v2ray","-d",o},
function(e)t[#t+1]=e end)
local t=n.split(table.concat(t))
e.exec("/bin/rm",{"-f",a})
return{code=0,file=o}
end
function to_move(n)
local a=check_path()
if a.code~=0 then
return a
end
if not n or n==""then
o.call("/bin/rm -rf /tmp/v2ray_extract.*")
return{code=1,error=t.translate("Client file is required.")}
end
local h=n.."/v2ray"
local n=e.get_v2ray_version(h)
if n==""then
o.call("/bin/rm -rf /tmp/v2ray_extract.*")
return{
code=1,
error=t.translate("The client file is not suitable for current device.")
}
end
local d=o.call('pgrep -af "passwall/.*v2ray" >/dev/null')
if d==0 then
o.call("/etc/init.d/passwall stop")
end
local r=0
if s.access(i)then
r=e.get_file_space(i)
end
local u=e.get_file_space(h)
local l=e.get_final_dir(i)
local n=e.get_free_space(l)
if n>0 then
n=n+r
if u>n then
o.call("/bin/rm -rf /tmp/v2ray_extract.*")
return{code=1,error=t.translatef("%s not enough space.",l)}
end
end
a=e.exec("/bin/mv",{"-f",h,i},nil,e.command_timeout)==0
o.call("/bin/rm -rf /tmp/v2ray_extract.*")
if d==0 then
o.call("/etc/init.d/passwall restart >/dev/null 2>&1 &")
end
if not a or not s.access(i)then
return{
code=1,
error=t.translatef("Can't move new file to path: %s",i)
}
end
return{code=0}
end
