local e=require"luci.model.cbi.passwall.api.api"
local t=e.appname
local l=e.uci
local c=e.datatypes
local r=e.is_finded("v2ray")
local d=e.is_finded("xray")
local h=e.fs.access("/usr/share/passwall/rules/chnlist")
m=Map(t)
local i={}
for t,e in ipairs(e.get_valid_nodes())do
i[#i+1]=e
end
local u={}
l:foreach(t,"socks",function(e)
if e.enabled=="1"and e.node then
local t,a
local o,n=e.node:match("^(tcp)")
if o then
a=translatef("Same as the tcp node")
else
for o,t in pairs(i)do
if(e.node==t.id)then
a=t["remark"];break
end
end
end
t="127.0.0.1"..":"..e.port
u[#u+1]={
id=t,
remarks=t.." - "..(a or translate("Misconfigured"))
}
end
end)
local f=function(a,t,a)
if t~=""then
t=e.trim(t)
local a=0
local e=require"luci.util"
local e=e.split(t,",")
local o=e[1]
e[1]=nil
for t=1,#e do
local e=e[t]
if e then
if not c.ipmask4(e)then
a=1
end
end
end
if a==0 then
return t
end
end
return nil,translate("DoH request address").." "..translate("Format must be:").." URL,IP"
end
local w=function(t,a,e)
local i=tcp_proxy_mode:formvalue(e)or""
local o=udp_proxy_mode:formvalue(e)or""
local t=localhost_tcp_proxy_mode:formvalue(e)or""
local e=localhost_udp_proxy_mode:formvalue(e)or""
local e=i..o..t..e
if e:find("returnhome")then
if e:find("chnroute")or e:find("gfwlist")then
return nil,translate("China list or gfwlist cannot be used together with outside China list!")
end
end
return a
end
m:append(Template(t.."/global/status"))
s=m:section(TypedSection,"global")
s.anonymous=true
s.addremove=false
s:tab("Main",translate("Main"))
o=s:taboption("Main",Flag,"enabled",translate("Main switch"))
o.rmempty=false
tcp_node=s:taboption("Main",ListValue,"tcp_node","<a style='color: red'>"..translate("TCP Node").."</a>")
tcp_node.description=""
local a=luci.sys.exec(string.format("[ -f '/tmp/etc/%s/id/TCP' ] && echo -n $(cat /tmp/etc/%s/id/TCP)",t,t))
if a and a~=""and a~="nil"then
local t=l:get_all(t,a)
if t then
if tonumber(m:get("@auto_switch[0]","enable")or 0)==1 then
local t=e.get_full_node_remarks(t)
local e=e.url("node_config",a)
tcp_node.description=tcp_node.description..translatef("Current node: %s",string.format('<a href="%s">%s</a>',e,t)).."<br />"
end
end
end
tcp_node:value("nil",translate("Close"))
if(r or d)and#i>0 then
local n={}
local a={}
for t,e in pairs(i)do
if e.node_type=="normal"then
n[#n+1]=e
end
if e.protocol and e.protocol=="_shunt"then
a[#a+1]=e
end
end
for i,a in pairs(a)do
l:foreach(t,"shunt_rules",function(i)
local t=i[".name"]
if t and i.remarks then
o=s:taboption("Main",ListValue,a.id.."."..t.."_node",string.format('* <a href="%s" target="_blank">%s</a>',e.url("shunt_rules",t),i.remarks))
o:depends("tcp_node",a.id)
o:value("nil",translate("Close"))
o:value("_default",translate("Default"))
o:value("_direct",translate("Direct Connection"))
o:value("_blackhole",translate("Blackhole"))
for t,e in pairs(n)do
o:value(e.id,e["remark"])
end
o.cfgvalue=function(e,e)
return m:get(a.id,t)or"nil"
end
o.write=function(o,o,e)
m:set(a.id,t,e)
end
end
end)
local e="default_node"
o=s:taboption("Main",ListValue,a.id.."."..e,string.format('* <a style="color:red">%s</a>',translate("Default")))
o:depends("tcp_node",a.id)
o:value("_direct",translate("Direct Connection"))
o:value("_blackhole",translate("Blackhole"))
for t,e in pairs(n)do
o:value(e.id,e["remark"])
end
o.cfgvalue=function(t,t)
return m:get(a.id,e)or"nil"
end
o.write=function(o,o,t)
m:set(a.id,e,t)
end
local e="main_node"
o=s:taboption("Main",ListValue,a.id.."."..e,string.format('* <a style="color:red">%s</a>',translate("Default Preproxy")),translate("When using, localhost will connect this node first and then use this node to connect the default node."))
o:depends("tcp_node",a.id)
o:value("nil",translate("Close"))
for t,e in pairs(n)do
o:value(e.id,e["remark"])
end
o.cfgvalue=function(t,t)
return m:get(a.id,e)or"nil"
end
o.write=function(o,o,t)
m:set(a.id,e,t)
end
end
end
udp_node=s:taboption("Main",ListValue,"udp_node","<a style='color: red'>"..translate("UDP Node").."</a>")
udp_node:value("nil",translate("Close"))
udp_node:value("tcp",translate("Same as the tcp node"))
s:tab("DNS",translate("DNS"))
if e.is_finded("smartdns")then
dns_shunt=s:taboption("DNS",ListValue,"dns_shunt",translate("DNS Shunt"))
dns_shunt:value("dnsmasq","Dnsmasq")
dns_shunt:value("smartdns","SmartDNS")
group_domestic=s:taboption("DNS",Value,"group_domestic",translate("Domestic group name"))
group_domestic.placeholder="local"
group_domestic:depends("dns_shunt","smartdns")
group_domestic.description=translate("You only need to configure domestic DNS packets in SmartDNS and set it redirect or as Dnsmasq upstream, and fill in the domestic DNS group name here.")
group_domestic.description=group_domestic.description..string.format('<a href="%s" target="_blank">%s</a>',"https://github.com/luckyyyyy/blog/issues/57",translate("Guide"))
end
o=s:taboption("DNS",Flag,"filter_proxy_ipv6",translate("Filter Proxy Host IPv6"),translate("Experimental feature."))
o.default="0"
dns_mode=s:taboption("DNS",ListValue,"dns_mode",translate("Filter Mode"))
dns_mode.rmempty=false
dns_mode:reset_values()
if e.is_finded("dns2tcp")then
dns_mode:value("dns2tcp",translatef("Requery DNS By %s","TCP"))
end
if e.is_finded("dns2socks")then
dns_mode:value("dns2socks","dns2socks")
end
if r then
dns_mode:value("v2ray","V2ray")
end
if d then
dns_mode:value("xray","Xray")
end
dns_mode:value("udp",translatef("Requery DNS By %s","UDP"))
o=s:taboption("DNS",ListValue,"v2ray_dns_mode"," ")
o:value("tcp","TCP")
o:value("doh","DoH")
o:value("fakedns","FakeDNS")
o:depends("dns_mode","v2ray")
o:depends("dns_mode","xray")
o.validate=function(a,e,t)
if e=="fakedns"then
local e=dns_mode:formvalue(t)
local t=tcp_node:formvalue(t)
if m:get(t,"type"):lower()~=e then
return nil,translatef("TCP node must be '%s' type to use FakeDNS.",e)
end
end
return e
end
o=s:taboption("DNS",Value,"socks_server",translate("Socks Server"),translate("Make sure socks service is available on this address."))
for t,e in pairs(u)do o:value(e.id,e.remarks)end
o.validate=function(t,e,t)
if not c.ipaddrport(e)then
return nil,translate("Socks Server").." "..translate("Not valid IP format, please re-enter!")
end
return e
end
o:depends({dns_mode="dns2socks"})
o=s:taboption("DNS",Value,"remote_dns",translate("Remote DNS"))
o.datatype="or(ipaddr,ipaddrport)"
o.default="1.1.1.1"
o:value("1.1.1.1","1.1.1.1 (CloudFlare)")
o:value("1.1.1.2","1.1.1.2 (CloudFlare-Security)")
o:value("8.8.4.4","8.8.4.4 (Google)")
o:value("8.8.8.8","8.8.8.8 (Google)")
o:value("9.9.9.9","9.9.9.9 (Quad9-Recommended)")
o:value("208.67.220.220","208.67.220.220 (OpenDNS)")
o:value("208.67.222.222","208.67.222.222 (OpenDNS)")
o:depends({dns_mode="dns2socks"})
o:depends({dns_mode="dns2tcp"})
o:depends({dns_mode="udp"})
o:depends({v2ray_dns_mode="tcp"})
o=s:taboption("DNS",Value,"remote_dns_doh",translate("Remote DNS DoH"))
o.default="https://1.1.1.1/dns-query"
o:value("https://1.1.1.1/dns-query","CloudFlare")
o:value("https://1.1.1.2/dns-query","CloudFlare-Security")
o:value("https://8.8.4.4/dns-query","Google 8844")
o:value("https://8.8.8.8/dns-query","Google 8888")
o:value("https://9.9.9.9/dns-query","Quad9-Recommended")
o:value("https://208.67.222.222/dns-query","OpenDNS")
o:value("https://dns.adguard.com/dns-query,176.103.130.130","AdGuard")
o:value("https://doh.libredns.gr/dns-query,116.202.176.26","LibreDNS")
o:value("https://doh.libredns.gr/ads,116.202.176.26","LibreDNS (No Ads)")
o.validate=f
o:depends("v2ray_dns_mode","doh")
o=s:taboption("DNS",Value,"dns_client_ip",translate("EDNS Client Subnet"))
o.description=translate("Notify the DNS server when the DNS query is notified, the location of the client (cannot be a private IP address).").."<br />"..
translate("This feature requires the DNS server to support the Edns Client Subnet (RFC7871).")
o.datatype="ipaddr"
o:depends("v2ray_dns_mode","tcp")
o:depends("v2ray_dns_mode","doh")
o=s:taboption("DNS",Flag,"dns_cache",translate("Cache Resolved"))
o.default="1"
o:depends({dns_mode="dns2socks"})
o:depends({dns_mode="v2ray",v2ray_dns_mode="tcp"})
o:depends({dns_mode="v2ray",v2ray_dns_mode="doh"})
o:depends({dns_mode="xray",v2ray_dns_mode="tcp"})
o:depends({dns_mode="xray",v2ray_dns_mode="doh"})
o.rmempty=false
if h and e.is_finded("chinadns-ng")then
o=s:taboption("DNS",Flag,"chinadns_ng",translate("ChinaDNS-NG"),translate("The effect is better, but will increase the memory."))
o.default="0"
if e.is_finded("smartdns")then
o:depends({dns_shunt="dnsmasq",dns_mode="dns2socks"})
o:depends({dns_shunt="dnsmasq",dns_mode="dns2tcp"})
o:depends({dns_shunt="dnsmasq",dns_mode="v2ray",v2ray_dns_mode="tcp"})
o:depends({dns_shunt="dnsmasq",dns_mode="v2ray",v2ray_dns_mode="doh"})
o:depends({dns_shunt="dnsmasq",dns_mode="xray",v2ray_dns_mode="tcp"})
o:depends({dns_shunt="dnsmasq",dns_mode="xray",v2ray_dns_mode="doh"})
o:depends({dns_shunt="dnsmasq",dns_mode="udp"})
else
o:depends({dns_mode="dns2socks"})
o:depends({dns_mode="dns2tcp"})
o:depends({dns_mode="v2ray",v2ray_dns_mode="tcp"})
o:depends({dns_mode="v2ray",v2ray_dns_mode="doh"})
o:depends({dns_mode="xray",v2ray_dns_mode="tcp"})
o:depends({dns_mode="xray",v2ray_dns_mode="doh"})
o:depends({dns_mode="udp"})
end
end
o=s:taboption("DNS",Button,"clear_ipset",translate("Clear IPSET"),translate("Try this feature if the rule modification does not take effect."))
o.inputstyle="remove"
function o.write(a,a)
luci.sys.call("[ -n \"$(nft list sets 2>/dev/null | grep \"gfwlist\")\" ] && /usr/share/"..t.."/nftables.sh flush_nftset || /usr/share/"..t.."/iptables.sh flush_ipset > /dev/null 2>&1 &")
luci.http.redirect(e.url("log"))
end
s:tab("Proxy",translate("Mode"))
tcp_proxy_mode=s:taboption("Proxy",ListValue,"tcp_proxy_mode","TCP "..translate("Default Proxy Mode"))
tcp_proxy_mode:value("disable",translate("No Proxy"))
tcp_proxy_mode:value("global",translate("Global Proxy"))
tcp_proxy_mode:value("gfwlist",translate("GFW List"))
tcp_proxy_mode:value("chnroute",translate("Not China List"))
if h then
tcp_proxy_mode:value("returnhome",translate("China List"))
end
tcp_proxy_mode:value("direct/proxy",translate("Only use direct/proxy list"))
tcp_proxy_mode.default="chnroute"
udp_proxy_mode=s:taboption("Proxy",ListValue,"udp_proxy_mode","UDP "..translate("Default Proxy Mode"))
udp_proxy_mode:value("disable",translate("No Proxy"))
udp_proxy_mode:value("global",translate("Global Proxy"))
udp_proxy_mode:value("gfwlist",translate("GFW List"))
udp_proxy_mode:value("chnroute",translate("Not China List"))
if h then
udp_proxy_mode:value("returnhome",translate("China List"))
end
udp_proxy_mode:value("direct/proxy",translate("Only use direct/proxy list"))
udp_proxy_mode.default="chnroute"
localhost_tcp_proxy_mode=s:taboption("Proxy",ListValue,"localhost_tcp_proxy_mode",translate("Router Localhost").." TCP "..translate("Proxy Mode"))
localhost_tcp_proxy_mode:value("default",translatef("Same as the %s default proxy mode","TCP"))
localhost_tcp_proxy_mode:value("global",translate("Global Proxy"))
localhost_tcp_proxy_mode:value("gfwlist",translate("GFW List"))
localhost_tcp_proxy_mode:value("chnroute",translate("Not China List"))
if h then
localhost_tcp_proxy_mode:value("returnhome",translate("China List"))
end
localhost_tcp_proxy_mode:value("disable",translate("No Proxy"))
localhost_tcp_proxy_mode:value("direct/proxy",translate("Only use direct/proxy list"))
localhost_tcp_proxy_mode.default="default"
localhost_udp_proxy_mode=s:taboption("Proxy",ListValue,"localhost_udp_proxy_mode",translate("Router Localhost").." UDP "..translate("Proxy Mode"))
localhost_udp_proxy_mode:value("default",translatef("Same as the %s default proxy mode","UDP"))
localhost_udp_proxy_mode:value("global",translate("Global Proxy"))
localhost_udp_proxy_mode:value("gfwlist",translate("GFW List"))
localhost_udp_proxy_mode:value("chnroute",translate("Not China List"))
if h then
localhost_udp_proxy_mode:value("returnhome",translate("China List"))
end
localhost_udp_proxy_mode:value("disable",translate("No Proxy"))
localhost_udp_proxy_mode:value("direct/proxy",translate("Only use direct/proxy list"))
localhost_udp_proxy_mode.default="default"
localhost_udp_proxy_mode.validate=w
tips=s:taboption("Proxy",DummyValue,"tips"," ")
tips.rawhtml=true
tips.cfgvalue=function(t,t)
return string.format('<a style="color: red" href="%s">%s</a>',e.url("acl"),translate("Want different devices to use different proxy modes/ports/nodes? Please use access control."))
end
s:tab("log",translate("Log"))
o=s:taboption("log",Flag,"close_log_tcp",translatef("%s Node Log Close","TCP"))
o.rmempty=false
o=s:taboption("log",Flag,"close_log_udp",translatef("%s Node Log Close","UDP"))
o.rmempty=false
loglevel=s:taboption("log",ListValue,"loglevel","V2ray/Xray "..translate("Log Level"))
loglevel.default="warning"
loglevel:value("debug")
loglevel:value("info")
loglevel:value("warning")
loglevel:value("error")
trojan_loglevel=s:taboption("log",ListValue,"trojan_loglevel","Trojan "..translate("Log Level"))
trojan_loglevel.default="2"
trojan_loglevel:value("0","all")
trojan_loglevel:value("1","info")
trojan_loglevel:value("2","warn")
trojan_loglevel:value("3","error")
trojan_loglevel:value("4","fatal")
s:tab("faq","FAQ")
o=s:taboption("faq",DummyValue,"")
o.template=t.."/global/faq"
o=s:taboption("Main",Flag,"socks_enabled","Socks "..translate("Main switch"))
o.rmempty=false
s=m:section(TypedSection,"socks",translate("Socks Config"))
s.anonymous=true
s.addremove=true
s.template="cbi/tblsection"
function s.create(t,a)
TypedSection.create(t,e.gen_uuid())
end
o=s:option(DummyValue,"status",translate("Status"))
o.rawhtml=true
o.cfgvalue=function(t,e)
return string.format('<div class="_status" socks_id="%s"></div>',e)
end
o=s:option(Flag,"enabled",translate("Enable"))
o.default=1
o.rmempty=false
socks_node=s:option(ListValue,"node",translate("Socks Node"))
socks_node:value("tcp",translate("Same as the tcp node"))
local e=0
l:foreach(t,"socks",function(t)
if t[".name"]==section then
return false
end
e=e+1
end)
o=s:option(Value,"port","Socks "..translate("Listen Port"))
o.default=e+1080
o.datatype="port"
o.rmempty=false
if r or d then
o=s:option(Value,"http_port","HTTP "..translate("Listen Port").." "..translate("0 is not use"))
o.default=0
o.datatype="port"
end
for t,e in pairs(i)do
tcp_node:value(e.id,e["remark"])
udp_node:value(e.id,e["remark"])
if e.type=="Socks"then
if r or d then
socks_node:value(e.id,e["remark"])
end
else
socks_node:value(e.id,e["remark"])
end
end
m:append(Template(t.."/global/footer"))
return m
